summaryrefslogtreecommitdiffstats
path: root/eshld
diff options
context:
space:
mode:
authorP. J. McDermott <pj@pehjota.net>2016-02-22 15:43:21 (EST)
committer P. J. McDermott <pj@pehjota.net>2016-02-22 15:43:21 (EST)
commit36cf5f8c449b67665b240e51731f903ebe146e8e (patch)
tree5f1f03c94f68a9a7505723313ff8533bf3bbae3a /eshld
parent18edfbff2c030ac2757c5ff295ed48cf919d37e8 (diff)
downloadeggshell-36cf5f8c449b67665b240e51731f903ebe146e8e.zip
eggshell-36cf5f8c449b67665b240e51731f903ebe146e8e.tar.gz
eggshell-36cf5f8c449b67665b240e51731f903ebe146e8e.tar.bz2
Add basic eshld
Diffstat (limited to 'eshld')
-rw-r--r--eshld/link.esh102
-rw-r--r--eshld/main.esh113
2 files changed, 215 insertions, 0 deletions
diff --git a/eshld/link.esh b/eshld/link.esh
new file mode 100644
index 0000000..d01fc4d
--- /dev/null
+++ b/eshld/link.esh
@@ -0,0 +1,102 @@
+# Eggshell Linker entry point
+#
+# Copyright (C) 2015 Patrick "P. J." McDermott
+#
+# This file is part of the Eggshell Linker.
+#
+# The Eggshell Linker is free software: you can redistribute it
+# and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of
+# the License, or (at your option) any later version.
+#
+# The Eggshell Linker is distributed in the hope that it will be
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the Eggshell Linker If not, see
+# <http://www.gnu.org/licenses/>.
+
+interpreter=
+entry_point=
+output=
+make_executable=
+
+die()
+{
+ local fmt="${1}"
+ shift 1
+
+ printf "eshld: ${fmt}\n" "${@}" >&2
+ exit 2
+}
+
+link_begin()
+{
+ local interp="${1}"
+ local entry="${2}"
+ local out="${3}"
+ local mkexec="${4}"
+ shift 4
+
+ interpreter="${interp}"
+ entry_point="${entry}"
+ output="${out}"
+ make_executable=${mkexec}
+
+ # Open output file.
+ if ! exec 3>"${output}~"; then
+ die 'Cannot open file "%s"' "${output}~"
+ fi
+
+ # Write magic number and interpreter path.
+ if ${make_executable}; then
+ printf '#!%s\n' "${interpreter}" >&3
+ fi
+
+ # Write __init() function.
+ cat >&3 <<-'EOF'
+ __init_funcs=''
+ __init()
+ {
+ __init_funcs="${__init_funcs} ${1}"
+ }
+ EOF
+
+}
+
+link_file()
+{
+ local input="${1}"
+
+ if ! cat "${input}" >&3; then
+ die 'Cannot read file "%s"' "${input}"
+ fi
+}
+
+link_end()
+{
+ # Add call to init functions.
+ cat >&3 <<-'EOF'
+ for __func in ${__init_funcs}; do
+ ${__func}
+ done
+ EOF
+
+ # Add call to entry point.
+ if ${make_executable}; then
+ printf '%s "${@}"\n' "${entry_point}" >&3
+ fi
+
+ # Close output file, make it executable, and set its name.
+ exec 3>&-
+ if ${make_executable}; then
+ if ! chmod a+x "${output}~"; then
+ die 'Cannot set mode of file "%s"' "${output}~"
+ fi
+ fi
+ if ! mv "${output}~" "${output}"; then
+ die 'Cannot rename file to "%s"' "${output}"
+ fi
+}
diff --git a/eshld/main.esh b/eshld/main.esh
new file mode 100644
index 0000000..775179f
--- /dev/null
+++ b/eshld/main.esh
@@ -0,0 +1,113 @@
+# Eggshell Linker entry point
+#
+# Copyright (C) 2015 Patrick "P. J." McDermott
+#
+# This file is part of the Eggshell Linker.
+#
+# The Eggshell Linker is free software: you can redistribute it
+# and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of
+# the License, or (at your option) any later version.
+#
+# The Eggshell Linker is distributed in the hope that it will be
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the Eggshell Linker If not, see
+# <http://www.gnu.org/licenses/>.
+
+set -u
+
+VERSION='0.1.0'
+
+usage()
+{
+ printf 'Usage: %s [option ...] <file>...\n' "${0}"
+}
+
+help()
+{
+ usage
+ cat <<EOF
+Options:
+ -h Display this information
+ -V Display linker version information
+ -I <interp> Use <interp> as the interpreter for your program, instead of the
+ default of "/bin/sh"
+ -e <entry> Use <entry> as the function for beginning execution of your
+ program, instead of the default of "main"
+ -o <output> Use <output> as the name of the program produced by eshld,
+ instead of the default of "out.sh"
+EOF
+}
+
+version()
+{
+ cat <<EOF
+eshld ${VERSION}
+Copyright (C) 2015 Patrick "P. J." McDermott
+License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
+This is free software: you are free to change and redistribute it.
+There is NO WARRANTY, to the extent permitted by law.
+EOF
+}
+
+main()
+{
+ local opt=
+ local interpreter=
+ local entry_point=
+ local output=
+ local make_executable=
+ local input=
+
+ interpreter='/bin/sh'
+ entry_point='main'
+ output='out.sh'
+ make_executable=true
+
+ while getopts 'hVI:e:o:' opt; do
+ case "${opt}" in
+ 'h')
+ help
+ return 0
+ ;;
+ 'V')
+ version
+ return 0
+ ;;
+ 'I')
+ interpreter="${OPTARG}"
+ ;;
+ 'e')
+ entry_point="${OPTARG}"
+ ;;
+ 'o')
+ output="${OPTARG}"
+ ;;
+ esac
+ done
+ shift $(($OPTIND - 1))
+
+ if [ ${#} -lt 1 ]; then
+ usage >&2
+ return 1
+ fi
+
+ if ! link_begin "${interpreter}" "${entry_point}" "${output}" \
+ ${make_executable}; then
+ return 1
+ fi
+ for input in "${@}"; do
+ if ! link_file "${input}"; then
+ return 1
+ fi
+ done
+ if ! link_end; then
+ return 1
+ fi
+
+ return 0
+}